package tdspp.SAKBUI;

import java.util.*;
import tdspp.util.*;
import java.awt.*;
import java.awt.event.*;
import Prism.core.*;

/**
 * This is the interface for the knowledge base and thus helps gather information from the user.
 *
 * It simply takes rules from the user and feeds them to the StratergyAnalysisKB.
 *
 * <table border=0> 
 * <tr> <td style="font-weight: bold; font-size: smaller"> Belongs to </td> <td> TDS++ </td>
 * <tr> <td style="font-weight: bold; font-size: smaller"> Properties </td> <td> Optional, User driven </td>
 * </table> 
 * 
 * @author 	TDS++ team, USC-CSE
 * @version 	1.0 , 22 Feb 2002
 * 
*/

public class SAKBUIImp extends GenericImp {
	/**
	 * Constructor
	 * 
	*/
	public SAKBUIImp(AbstractImplementation parent) {
		super(parent);
	}
	public SAKBUIImp (){
		
	}

	
	/**
	 * Update a particular rule in the KB.
	 * Called by: None.
	 * 
	 * @param rule	The rule to be Updated.
	 * @see 	StrategyAnalysisKBImp#updateRule
	 * @return	void
	 * 
	*/
	public void updateRule(String factor, Integer number) {
		((SAKBUI)parent).updateRule(factor,number);
		//System.out.println("SAKBUIImp: returned from SAKBUI");
	}
	
	/**
	 * show the UI
	 */
	public void show(Frame parent, String[] factors) {
		//SAKBUIDialog dlg = new SAKBUIDialog(parent, this, factors);
		Frame invisibleFrame = new Frame();
		SAKBUIDialog dlg = new SAKBUIDialog(invisibleFrame, this, factors);
		dlg.pack();
		dlg.setVisible(true);
	}
}

class SAKBUIDialog extends Dialog implements ActionListener
{

  private TextField tfNum;
  private Choice chFactor = new Choice();
  private Button btUpdate; // Declare "Update" button
  private Button btClose; // Declare "Close" button
  SAKBUIImp parent = new SAKBUIImp();
  
  

// Constructor
public SAKBUIDialog(Frame frm,SAKBUIImp sakbImp, String[] factors){
	super(frm,true);//modal dialog is used
	parent = sakbImp;
	setTitle("SAKBUI");

	// Use panel p1 to group text fields
	Panel p1 = new Panel();
	p1.setLayout(new FlowLayout());
	p1.add(new Label("Factor"));
	for (int i = 0; i<factors.length; i++)
		 chFactor.addItem(factors[i]);
	p1.add(chFactor);
   //Use panel p3 for value field
	Panel p3 = new Panel();
	p3.setLayout(new FlowLayout());
	p3.add(new Label("Value"));
   p3.add(tfNum = new TextField(3));
    
	// Use panel p2 for the buttons
	Panel p2 = new Panel();
	p2.setLayout(new FlowLayout());
	p2.add(btUpdate = new Button("Update"));
	p2.add(btClose = new Button("Close"));

    // Set FlowLayout for the frame and add panels to the frame
    setLayout(new BorderLayout());
    add(p1, BorderLayout.NORTH);
	 add(p3, BorderLayout.WEST);
    add(p2, BorderLayout.SOUTH);

    // Register listener
    
	btUpdate.addActionListener(this);
	btClose.addActionListener(this);
  }

  // Handle the Store operation
  public void actionPerformed(ActionEvent e){
	  
      String factor = chFactor.getSelectedItem();
      String number = tfNum.getText().trim();
	  int num = 0;
	  //System.out.println (number.length());
	  if (number.length() != 0) num = (Integer.parseInt(number));
	  
	  /*
	  if (e.getSource() == btStore) {
		  //if (factor.length() != 0) testSAKB.storeRule(factor, num);
	  }
	  */
	  if (e.getSource() == btUpdate) {
		  //System.out.println("update button pressed");
		  try{
			  if (number.length() != 0) num = (Integer.parseInt(number));
			  
			  parent.updateRule(factor, new Integer(num));  
			  //System.out.println("action Listener: entered number is "+num);
		  }
		  catch (NumberFormatException exc){
			//show Message
			  
		  }
	  }
	  /*
	  else if (e.getSource() == btDelete) {
		  //if (factor.length() != 0) testSAKB.deleteRule(factor);
	  }
	  */
	  else if (e.getSource() == btClose) {
		  //System.out.println("Closing...");
		  this.setVisible(false);    // hide the Frame
		  this.dispose();            // free the system resources
	  }
	  //System.out.println("Size of rules = "+testSAKB.rules.size());
	  //tfFactor.setText("");
	  tfNum.setText("");
  }
}
