package tdspp.StrategyAnalyzerAgent;
import Prism .core.* ;
import tdspp .util .*;
import java.util .*;


/**
 * The strategy anlyzer agent component. Makes use of class StrategyAnalyzerAgentImp.
 *
 * @see		StrategyAnalyzerAgentImp
 * @author 	TDS++ team, USC-CSE
 * @version 	1.0 , 18 Feb 2002
 *
*/

public class StrategyAnalyzerAgent extends AbstractImplementation {
	/**
	 * The StrategyAnalyzerAgentImp object
	 *
	 */
	StrategyAnalyzerAgentImp saaIO;
	Event nn;
	Event rr;
	String name;



	/**
	 * Default constructor
	 */
	public StrategyAnalyzerAgent() {
		this("StrategyAnalyzerAgent");
	}

	public StrategyAnalyzerAgent (String name){
		this.name = name;
		saaIO = new StrategyAnalyzerAgentImp ();


	}

	/**
	 * Handling the Requests
	 *
	 * @param r	Request
	 * @return 	void
	 *
	 */
	public void handle (Event r) {
		if (r.name.equals (tdspp.util.MessageConstants.MESSAGE_NAME_ANALYZESTRATEGY )){
			saaIO.setRegions ((Region[]) r.getParameter (tdspp.util.MessageConstants.PARAM_NAME_GETMAPRESP_REGIONS ));
			//SAKB communication
			rr = new Event (tdspp.util.MessageConstants.MESSAGE_NAME_GETRULES );
			rr.eventType=PrismConstants.REQUEST;
			rr.addParameter (tdspp.util.MessageConstants.PARAM_NAME_ID , new String (name));
			send (rr);
		}
		else handleN(r);
	}

	/**
	 * Handling the Notifications
	 *
	 * @param r	Notification
	 * @return 	void
	 *
	 */
	public void handleN (Event n) {
		if (n.name.equals (tdspp.util.MessageConstants.MESSAGE_NAME_GETRULESRESP)){
			String idName = (String) n.getParameter (tdspp.util.MessageConstants.PARAM_NAME_ID );
			//System.out.println("saa.idName= "+idName);
			//System.out.println("saa.name= "+name);
			if (idName.equals(name)){
				//System.out.println("saa.idName= "+idName);
				saaIO.setLocalRules ((Hashtable) n.getParameter (tdspp.util.MessageConstants.PARAM_NAME_GETRULESRESP ));
				saaIO.analyzeStrategy ();

				if (saaIO.isValid ()) {
					nn = new Event (tdspp.util.MessageConstants.MESSAGE_NAME_ANALYZESTRATEGYVALIDRESP );
					nn.eventType=PrismConstants.REPLY;
							}
				else {
					nn = new Event (tdspp.util.MessageConstants.MESSAGE_NAME_ANALYZESTRATEGYINVALIDRESP );
					nn.eventType=PrismConstants.REPLY;
					nn.addParameter (tdspp.util.MessageConstants.PARAM_NAME_INVALIDRESPREGION , saaIO.getInvalidRegion());
					nn.addParameter (tdspp.util.MessageConstants.PARAM_NAME_INVALIDRESPLEVEL , saaIO.getInvalidLevel());
				}
				send (nn);
			}
		}
	}
}
