package tdspp.apps;

import Prism.core.*;
import Prism.conn.basic.*;
import Prism.conn.distribution.bottom.*;
import Prism.conn.distribution.top.*;
import Prism.util.*;

import tdspp.Clock.*;
import tdspp.DeploymentAdvisor.*;
import tdspp.Map.*;
import tdspp.RenderingAgent.*;
import tdspp.Repository.*;
import tdspp.ResourceManager.*;
import tdspp.ResourceMonitor.*;
import tdspp.SAKBUI.*;
import tdspp.SimulationAgent.*;
import tdspp.StrategyAnalysisKB.*;
import tdspp.StrategyAnalyzerAgent.*;
import tdspp.util.*;
import tdspp.Weather.*;
import tdspp.WeatherAnalyzer.*;

/**
 *
 * This is the sample main class that executes the application as the General.
 *
 */

public class headquarters
{
	/**
	 * The main method
	 */
	public static void main(String argv[]) {
		FIFOScheduler sched = new FIFOScheduler(500);//size of the message queue
		Scaffold s = new Scaffold();
		RRobinDispatcher disp = new  RRobinDispatcher(sched, 2);
		s.dispatcher=disp;
		s.scheduler=sched;    
		//DOOVDE
		Architecture arch=new Architecture("General");
		arch.scaffold=s;
		System.out.println("Creating the architecture");

		
		Clock clk = new Clock("clock");
		Component clkC=new Component("clock");
		clkC.setImplementation( clk);
		clkC.scaffold=s;
		arch.add(clkC);

		

		Weather wth = new Weather("weatherG");
		Component wthC=new Component("weatherG");
		wthC.setImplementation(wth);
		wthC.scaffold=s;
		wth.setUpdateParams(0.5, 0.6, 0.3, 0.2, 0.4, 2, 2, 5,3);
		wth.setUIUpdInterval(50);
		wth.setUpdInterval(10);

		Repository rep = new Repository("repos");
		if(argv.length > 2) rep.setFilename(argv[3]);
		Component repC=new Component("repos");
		repC.setImplementation( rep);
		repC.scaffold=s;
		

		
		Map map = new Map("map");
		Component mapC=new Component("map");
		mapC.setImplementation( map);
		mapC.scaffold=s;
		
		WeatherAnalyzer wthan = new WeatherAnalyzer("weatherAnalysis");
		Component wthanC=new Component("weatherAnalysis");
		wthanC.setImplementation( wthan);
		wthanC.scaffold=s;

		ResourceManager resmgr = new ResourceManager("resMgr");
		Component resmgrC=new Component("resMgr");
		resmgrC.setImplementation( resmgr);
		resmgrC.scaffold=s;

		StrategyAnalysisKB sakb = new StrategyAnalysisKB("SAKB");
		Component sakbC=new Component("SAKB");
		sakbC.setImplementation( sakb);
		sakbC.scaffold=s;

		


		arch.add(clk);
		arch.add(c1);
		arch.add(wth);
		arch.add(rep);
		arch.add(c2);
		arch.add(map);
		arch.add(c3);
		arch.add(wthan);
		arch.add(resmgr);
		arch.add(sakb);
		arch.add(bbc);

		arch.weld(clk,c1);
		arch.weld(c1,wth);
		arch.weld(c1,rep);
		arch.weld(wth,c2);
		arch.weld(c1,c2);
		arch.weld(rep,c2);

		arch.weld(c2,map);
		arch.weld(c2,c3);
		arch.weld(map,c3);

		arch.weld(c2,wthan);

		arch.weld(c3,resmgr);
		arch.weld(c3,sakb);
		arch.weld(wthan,bbc);

		arch.weld(c3,bbc);
		arch.weld(resmgr,bbc);
		arch.weld(sakb,bbc);

		System.out.println("Architecture looks like " + arch);

		// start it
		sch.start();
		arch.start();
		System.out.println("Architecture started ");
	}

}