package tdspp.util;

import java.io.*;

/**
 * TerrainDesc class gives the terrain description of the cell.
 *
 * There are only a fixed set of values for the terrain description.
 *
 * <table border=0>
 * <tr> <td style="font-weight: bold; font-size: smaller"> Belongs to </td> <td> TDS++ </td>
 * <tr> <td style="font-weight: bold; font-size: smaller"> Propertie </td> <td> Utility </td>
 * </table>
 *
 * @author 	TDS++ team, USC-CSE
 * @version 	1.0 , 23 May 2002
 *
*/

public class TerrainDesc implements Cloneable, Serializable  {
	/**
	 * Terrain type.
	 *
	 */
	public int type;

	/**
	 * Constructor
	 */
	public TerrainDesc() {
		this.type = Constants.TERRAINTYPE_FLAT;
	}

	/**
	 * set type
	 */
	public void setType(int type){

		this.type = type;

	}

	/**
	 * get type
	 *
	 */
	public int getType(){
		return this.type;
	}

	/**
	 * cloning function
	 */
	public Object clone() {
		Object o = null;
		try {
			o = super.clone();
		} catch(CloneNotSupportedException e) {
			e.printStackTrace(System.err);
		}
		return o;
	}

	public String toString() {
		return "" + type;
	}


		public String toXML(){
			String output = "";
			output += "<TerrainDesc type=class>";
			output += "<type type=Integer>" + type + "</type>";
			output += "</TerrainDesc>";
			return output;
		}

}
